var V = Object.defineProperty;
var f = (e) => {
  throw TypeError(e);
};
var b = (e, t, s) => t in e ? V(e, t, { enumerable: !0, configurable: !0, writable: !0, value: s }) : e[t] = s;
var o = (e, t, s) => b(e, typeof t != "symbol" ? t + "" : t, s), U = (e, t, s) => t.has(e) || f("Cannot " + s);
var h = (e, t, s) => (U(e, t, "read from private field"), s ? s.call(e) : t.get(e)), Y = (e, t, s) => t.has(e) ? f("Cannot add the same private member more than once") : t instanceof WeakSet ? t.add(e) : t.set(e, s), d = (e, t, s, r) => (U(e, t, "write to private field"), r ? r.call(e, s) : t.set(e, s), s);
var c = /* @__PURE__ */ ((e) => (e[e.CREATE_PROMISE_FAILED = 1] = "CREATE_PROMISE_FAILED", e[e.TIMEOUT = 2] = "TIMEOUT", e[e.ABORT = 3] = "ABORT", e[e.RETRY_EXCEED_LIMIT = 4] = "RETRY_EXCEED_LIMIT", e[e.RETRY_CAN_RETRY_FN_FAILED = 5] = "RETRY_CAN_RETRY_FN_FAILED", e[e.RETRY_DELAY_FN_FAILED = 6] = "RETRY_DELAY_FN_FAILED", e))(c || {}), i = /* @__PURE__ */ ((e) => (e[e.NOT_STARTED = -1] = "NOT_STARTED", e[e.PENDING = 0] = "PENDING", e[e.FULFILLED = 1] = "FULFILLED", e[e.REJECTED = 2] = "REJECTED", e))(i || {});
const W = {
  [c.CREATE_PROMISE_FAILED]: "创建Promise失败",
  [c.TIMEOUT]: "超时",
  [c.ABORT]: "中止",
  [c.RETRY_EXCEED_LIMIT]: "重试超出限制",
  [c.RETRY_CAN_RETRY_FN_FAILED]: "重试判断是否可以重试函数执行失败",
  [c.RETRY_DELAY_FN_FAILED]: "重试延迟函数执行失败"
};
class _ extends Error {
  constructor(t, s = W[t]) {
    super(s), this.code = t;
  }
}
const P = (e, t) => {
  try {
    return e();
  } catch (s) {
    return t(s);
  }
}, v = (e) => P(e, (t) => new Promise((s, r) => {
  r(
    new _(
      c.CREATE_PROMISE_FAILED,
      (t == null ? void 0 : t.message) || void 0
    )
  );
})), J = (e, { rejectClean: t = !0, resolveClean: s = !0 } = {}) => {
  let r, n = i.NOT_STARTED;
  return {
    /** 获取promise状态 */
    getStatus: () => n,
    /** 是否存在promise */
    isHasPromise: () => n !== i.NOT_STARTED,
    /** 应用promise */
    applyPromise: () => r || (n = i.PENDING, r = v(() => e()), r.then(() => {
      n = i.FULFILLED, s && (r = void 0, console.log("Promise sharing: promise resolve，已重置"));
    }).catch(() => {
      n = i.REJECTED, t && (r = void 0, console.log("Promise sharing: promise reject，已重置"));
    }), r.finally(() => {
      n = i.NOT_STARTED;
    }), r),
    /** 清除promise */
    clearPromise: async () => {
      switch (n) {
        case i.NOT_STARTED: {
          console.warn("Promise sharing: promise clear，promise未开始");
          return;
        }
        case i.PENDING:
          return console.warn("Promise sharing: promise clear，promise等待中"), r.finally(() => {
            r = void 0;
          });
        case i.FULFILLED:
        case i.REJECTED: {
          r = void 0;
          return;
        }
      }
    },
    /** 获取当前promise */
    getCurrentPromise: () => r
  };
};
class m extends _ {
  constructor(s) {
    super(
      s.code,
      s.message || `包括首次执行, 总共执行${s.retryCount + 1}次, 总共运行耗时${s.runTime}ms, 最终仍失败`
    );
    /** 重试次数 */
    o(this, "retryCount");
    /** 运行时间 */
    o(this, "runTime");
    /** 错误列表 */
    o(this, "errorMessageList");
    this.retryCount = s.retryCount, this.runTime = s.runTime, this.errorMessageList = s.errorMessageList;
  }
  /** 创建重试错误 */
  static create(s) {
    return new m(s);
  }
}
const H = (e, {
  maxRetry: t = 0,
  maxRunTime: s = 1 / 0,
  maxErrorMessageListLength: r = 10,
  canRetry: n = ({ retryCount: I, runTime: y }) => I < Math.max(t, 0) && y < s,
  delay: F = 0
}) => {
  const I = Math.max(r, 1), y = typeof F == "function" ? F : () => F;
  let w = !1, g;
  const z = () => {
    let T = 0, Z = Date.now();
    const l = [], $ = new Promise((k, p) => {
      const O = () => {
        v(() => e(T)).then(k).catch((L) => {
          l.push((L == null ? void 0 : L.message) || "未知错误");
          const S = l.length, C = Math.max(
            S - I,
            0
          );
          C > 0 && l.splice(
            S - C,
            C
          );
          const R = Date.now() - Z;
          if (P(
            () => n({ retryCount: T, runTime: R }, L),
            (D) => {
              const u = m.create({
                retryCount: T,
                runTime: R,
                errorMessageList: l,
                code: c.RETRY_CAN_RETRY_FN_FAILED,
                message: (D == null ? void 0 : D.message) || void 0
              });
              throw p(u), u;
            }
          )) {
            if (w)
              return p(
                m.create({
                  retryCount: T,
                  runTime: R,
                  errorMessageList: l,
                  code: c.ABORT
                })
              );
            T++;
            const D = P(
              () => y({ retryCount: T, runTime: R }, L),
              (u) => {
                const G = m.create({
                  retryCount: T,
                  runTime: R,
                  errorMessageList: l,
                  code: c.RETRY_DELAY_FN_FAILED,
                  message: (u == null ? void 0 : u.message) || void 0
                });
                throw p(G), G;
              }
            );
            if (D > 0) {
              const u = setTimeout(O, D);
              g = () => {
                clearTimeout(u), p(
                  m.create({
                    retryCount: T,
                    runTime: R,
                    errorMessageList: l,
                    code: c.ABORT
                  })
                );
              };
            } else
              O();
          } else
            p(
              m.create({
                retryCount: T,
                runTime: R,
                errorMessageList: l,
                code: c.RETRY_EXCEED_LIMIT
              })
            );
        }).finally(() => {
          g = void 0;
        });
      };
      O();
    });
    return $.finally(() => {
      w = !1;
    }), $;
  }, { getStatus: x, applyPromise: K, getCurrentPromise: Q } = J(
    z,
    {
      rejectClean: !0,
      resolveClean: !0
    }
  );
  return {
    /** 开始重试 */
    startRetry: () => K(),
    /** 停止重试 */
    stopRetry: () => (w = !0, g == null || g(), Q()),
    /** 获取重试状态 */
    getStatus: x,
    /** 判断是在重试中 */
    isRetrying: () => x() === i.PENDING
  };
};
class q extends _ {
  constructor(t = W[c.ABORT]) {
    super(c.ABORT, t);
  }
}
var A;
const N = class N {
  constructor(t) {
    /** promise原始reject函数 */
    Y(this, A);
    d(this, A, t);
  }
  /** 取消 promise */
  cancel(t) {
    h(this, A).call(this, t);
  }
};
A = new WeakMap(), /** 是否取消错误 */
o(N, "isCancelError", (t) => t instanceof q), /** 创建 promise 取消令牌 */
o(N, "source", (t) => new N(t));
let M = N;
function X(e, t) {
  return v(e).catch(() => typeof t == "function" ? t() : t);
}
const tt = (...e) => {
  const {
    startRetry: t,
    stopRetry: s,
    getStatus: r,
    isRetrying: n
  } = H(...e);
  return {
    /** 开始轮询 */
    startPolling: t,
    /** 停止轮询 */
    stopPolling: s,
    /** 获取轮询状态 */
    getStatus: r,
    /** 判断是在轮询中 */
    isPolling: n
  };
};
let et = 0;
const st = (e, t) => (s, r) => {
  t.resolveWrap = (n) => {
    if (t.state !== i.PENDING) {
      console.log(`当前状态已经变为${t.state}, 忽略resolve`);
      return;
    }
    t.endTime = Date.now(), console.log(
      `${t.index} 调用成功${t.num++}次`,
      n,
      `耗时${t.endTime - t.startTime}ms`
    ), t.state = i.FULFILLED, t.clearTimeoutTimer(), s(n);
  }, t.rejectWrap = (n) => {
    if (t.state !== i.PENDING) {
      console.log(`当前状态已经变为${t.state}, 忽略reject`);
      return;
    }
    t.endTime = Date.now(), console.log(
      `${t.index} 调用失败${t.num++}次`,
      n,
      `耗时${t.endTime - t.startTime}ms`
    ), t.state = i.REJECTED, t.clearTimeoutTimer(), r(n);
  }, e(t.resolveWrap, t.rejectWrap);
}, rt = (e) => {
  const t = {
    timeoutTimer: void 0,
    clearTimeoutTimer() {
      this.timeoutTimer && (clearTimeout(this.timeoutTimer), this.timeoutTimer = void 0);
    },
    startTime: Date.now(),
    state: i.PENDING,
    num: 0,
    index: et++
  }, s = st(e, t);
  return t.promise = new Promise(s), t.promise.catch((r) => {
    var n;
    return t.state === i.PENDING && (console.log("promise 内部出现pending状态错误", r), (n = t.rejectWrap) == null || n.call(t, r)), r;
  }), {
    baseInfo: t
  };
};
var B, E;
B = Symbol.toStringTag;
const a = class a {
  constructor(t) {
    o(this, B, `object ${a.name}`);
    /** 原始promise上下文 */
    Y(this, E);
    /** 超时设置 */
    o(this, "timeout", (t) => {
      const { baseInfo: s } = h(this, E);
      if (s.state !== i.PENDING)
        return console.warn("超时设置失败，promise状态不为pending"), this;
      s.clearTimeoutTimer();
      const r = Math.max(0, s.startTime + t - Date.now());
      return console.log(`超时设置${t}ms, 剩余${r}ms`), s.timeoutTimer = setTimeout(() => {
        console.log("走到超时时刻"), s.rejectWrap(new _(c.TIMEOUT));
      }, r), this;
    });
    /** 中止promise */
    o(this, "abort", (t) => {
      const { baseInfo: s } = h(this, E);
      return s.state !== i.PENDING ? (console.warn("取消失败，promise状态不为pending"), this) : (M.source((n) => {
        s.rejectWrap(new q(n));
      }).cancel(t), this);
    });
    d(this, E, rt(t));
  }
  // 修正 then 方法
  then(t, s) {
    return new a((r, n) => {
      h(this, E).baseInfo.promise.then(t, s).then(r, n);
    });
  }
  // 修正 catch 方法
  catch(t) {
    return this.then(void 0, t);
  }
  // 修正 finally 方法
  finally(t) {
    return new a((s, r) => {
      h(this, E).baseInfo.promise.finally(t).then(s, r);
    });
  }
};
E = new WeakMap(), /** promise共享 */
o(a, "useSharing", J), /** promise重试 */
o(a, "useRetry", H), /** promise轮询 */
o(a, "usePolling", tt), /** promise无错 */
o(a, "noReject", X), /** 是否是取消/中止错误 */
o(a, "isCancelError", M.isCancelError), /** 是否是超时错误 */
o(a, "isTimeoutError", (t) => t instanceof _ && t.code === c.TIMEOUT);
let j = a;
export {
  j as XPromise,
  q as XPromiseCancelError,
  M as XPromiseCancelToken,
  _ as XPromiseError,
  c as XPromiseErrorCodeEnum,
  m as XPromiseRetryError,
  X as promiseNoReject,
  tt as usePromisePolling,
  H as usePromiseRetry,
  J as usePromiseSharing
};
